=== debian/changelog ===
tiledarray (0.6.0-5) unstable; urgency=medium

  * debian/rules (BUILD_TYPE): New variable, set to `MinSizeRel' on mips64el
    and to `none' (dh's default) otherwise.
  * debian/rules (override_dh_auto_configure): Set CMAKE_BUILD_TYPE to
    $BUILD_TYPE.
  * debian/rules (override_dh_auto_test): No longer disable the testsuite on
    mipsel64.
  * debian/rules (EXCLUDE_TESTS): New variable, set to exclude the eigen_suite
    tests on mips64el.
  * debian/rules (override_dh_auto_test): Add logging output and use
    $EXCLUDE_TESTS.

 -- Michael Banck <mbanck@debian.org>  Fri, 13 Jan 2017 23:38:33 +0100

tiledarray (0.6.0-4) unstable; urgency=medium

  * debian/rules (override_dh_auto_configure): Add -DCMAKE_BUILD_TYPE=Release
    to address linking errors on mips64el.

 -- Michael Banck <mbanck@debian.org>  Fri, 13 Jan 2017 10:29:28 +0100

tiledarray (0.6.0-3) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Disable testsuite on mips64el.

 -- Michael Banck <mbanck@debian.org>  Tue, 10 Jan 2017 18:17:52 +0100

tiledarray (0.6.0-2) unstable; urgency=medium

  * debian/rules: Add -mxgot to CXX_FLAGS on mips architectures, thanks to
    Graham Inggs.

 -- Michael Banck <mbanck@debian.org>  Mon, 09 Jan 2017 15:00:19 +0100

tiledarray (0.6.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/madness_to_version_0.10.patch: Removed, no longer needed.
  * debian/patches/madness_fix_includes.patch: Likewise.
  * debian/patches/boost1.59.patch: Likewise.
  * debian/control (Build-Depends): Replaced mpi-default-dev and
    mpi-default-bin with libmpich-dev and mpich.
  * debian/rules: Do not include /usr/share/mpi-default-dev/debian_defaults
    anymore.
  * debian/rules (override_dh_auto_configure): Add TA_ERROR="throw"  and
    ENABLE_SHARED_LIBRARIES=OFF to cmake configure flags.
  * debian/control (Build-Depends): Added pkg-config.
  * debian/rules (override_dh_auto_configure): Add CMAKE_CXX_FLAGS and
    CMAKE_EXE_LINKER_FLAGS variables to cmake configure flags, set by
    pkg-config.
  * debian/control (Build-Depends): Bump libmadness-dev version to
    0.10.1~gite4aa500e-10 (Closes: #848781).
  * debian/control (Build-Depends): Added libtbb-dev.

 -- Michael Banck <mbanck@debian.org>  Sun, 01 Jan 2017 11:57:28 +0100
