=== debian/control ===
Source: tiledarray
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libblas-dev,
               libboost-dev,
               libeigen3-dev,
               liblapack-dev,
               libmadness-dev (>= 0.10.1~gite4aa500e-10),
               libmpich-dev,
               libtbb-dev,
               mpich,
               openssh-client,
               pkg-config
Standards-Version: 3.9.8
Homepage: https://github.com/ValeevGroup/tiledarray
Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/tiledarray/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/tiledarray/

Package: libtiledarray-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Block-Sparse Tensor Library (development files)
 TiledArray is a scalable, block-sparse tensor library that is designed
 to aid in rapid composition of high-performance tensor expressions,
 appearing for example in many-body quantum mechanics. It allows users
 to compose tensor expressions of arbitrary complexity that closely
 resembles the standard mathematical notation.
 .
 This package contains the static libraries and the header files.
